; Script generated with the Venis Install Wizard

; Define your application name
!define APPNAME "Notepad++"
!define APPNAMEANDVERSION "Notepad++ 2.2"

; Main Install settings
Name "${APPNAMEANDVERSION}"
InstallDir "$PROGRAMFILES\Notepad++"
InstallDirRegKey HKLM "Software\${APPNAME}" ""
OutFile "npp.2.2.Installer.exe"

; Modern interface settings
!include "MUI.nsh"

!define MUI_ABORTWARNING
!define MUI_FINISHPAGE_RUN "$INSTDIR\notepad++.exe"

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "..\license.txt"
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

; Set languages (first is default language)
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_RESERVEFILE_LANGDLL

Section "Notepad++" Section1

	; Set Section properties
	SetOverwrite on

	; Set Section Files and Shortcuts
	SetOutPath "$INSTDIR\"
	File "LINEDRAW.TTF"
	File "SciLexer.dll"
	File "chang.log"
	File "config.xml"
	File "langs.xml"
	File "notepad++.exe"
	File "readme.txt"
	File "stylers.xml"

	
	SetOutPath "$APPDATA\Notepad++"
	File "stylers.xml"
	File "config.xml"
	
	IfFileExists "$INSTDIR\plugins\APIs" doNothing createDir

	createDir:
	CreateDirectory "$INSTDIR\plugins"
	CreateDirectory "$INSTDIR\plugins\APIs"
	
	doNothing:
	
	IfFileExists "$INSTDIR\plugins\APIs\php.api" skipPhp copyPhp
	
	copyPhp:
	SetOutPath "$INSTDIR\plugins\APIs"
	File ".\plugins\APIs\php.api"
	
	skipPhp:
	
	IfFileExists "$INSTDIR\plugins\APIs\css.api" skipCss copyCss
	
	copyCss:
	SetOutPath "$INSTDIR\plugins\APIs"
	File ".\plugins\APIs\css.api"
	
	skipCss:
	
	CreateShortCut "$DESKTOP\Notepad++.lnk" "$INSTDIR\notepad++.exe"
	CreateDirectory "$SMPROGRAMS\Notepad++"
	CreateShortCut "$SMPROGRAMS\Notepad++\Notepad++.lnk" "$INSTDIR\notepad++.exe"
	CreateShortCut "$SMPROGRAMS\Notepad++\Uninstall.lnk" "$INSTDIR\uninstall.exe"

SectionEnd

Section -FinishSection

	WriteRegStr HKLM "Software\${APPNAME}" "" "$INSTDIR"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "DisplayName" "${APPNAME}"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "UninstallString" "$INSTDIR\uninstall.exe"
	WriteUninstaller "$INSTDIR\uninstall.exe"

SectionEnd

; Modern install component descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT ${Section1} ""
!insertmacro MUI_FUNCTION_DESCRIPTION_END

;Uninstall section
Section Uninstall

	;Remove from registry...
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}"
	DeleteRegKey HKLM "SOFTWARE\${APPNAME}"

	; Delete self
	Delete "$INSTDIR\uninstall.exe"

	; Delete Shortcuts
	Delete "$DESKTOP\Notepad++.lnk"
	Delete "$SMPROGRAMS\Notepad++\Notepad++.lnk"
	Delete "$SMPROGRAMS\Notepad++\Uninstall.lnk"

	; Clean up Notepad++
	Delete "$INSTDIR\LINEDRAW.TTF"
	Delete "$INSTDIR\SciLexer.dll"
	Delete "$INSTDIR\chang.log"
	Delete "$INSTDIR\config.xml"
	Delete "$INSTDIR\langs.xml"
	Delete "$INSTDIR\notepad++.exe"
	Delete "$INSTDIR\readme.txt"
	Delete "$INSTDIR\stylers.xml"

	; Remove remaining directories
	RMDir "$SMPROGRAMS\Notepad++"
	RMDir "$INSTDIR\"

SectionEnd

BrandingText "Don HO"

; eof